package com.fs.qw.service;

import com.alibaba.fastjson.JSONObject;
import com.fs.common.core.domain.R;
import com.fs.qw.domain.QwContactWay;
import com.fs.qw.domain.QwExternalContact;
import com.fs.qw.domain.QwUser;
import com.fs.qw.param.QwStatisticsParam;
import com.fs.qw.vo.QwWayStatisticsListVO;

import java.util.List;
import java.util.Map;

/**
 * 企微活码Service接口
 *
 * @author fs
 * @date 2024-07-05
 */
public interface IQwContactWayService
{
    /**
     * 查询企微活码
     *
     * @param id 企微活码主键
     * @return 企微活码
     */
    public QwContactWay selectQwContactWayById(Long id);

    /**
     * 查询企微活码列表
     *
     * @param qwContactWay 企微活码
     * @return 企微活码集合
     */
    public List<QwContactWay> selectQwContactWayList(QwContactWay qwContactWay);

    /**
     * 新增企微活码
     *
     * @param qwContactWay 企微活码
     * @return 结果
     */
    public R insertQwContactWay(QwContactWay qwContactWay);

    /**
     * 修改企微活码
     *
     * @param qwContactWay 企微活码
     * @return 结果
     */
    public R updateQwContactWay(QwContactWay qwContactWay);

    /**
     * 批量删除企微活码
     *
     * @param ids 需要删除的企微活码主键集合
     * @return 结果
     */
    public R deleteQwContactWayByIds(Long[] ids);

    /**
     * 删除企微活码信息
     *
     * @param id 企微活码主键
     * @return 结果
     */
    public int deleteQwContactWayById(Long id);

    R selectQwContactWaysync(String corpId);

    void updateQwContactWayBYLimit(Long wayId);


    boolean sendWelcomeMsg(QwContactWay qwContactWay, String corpId, String welcomeCode, QwUser qwUser,Long qwExternalId);

    List<QwWayStatisticsListVO> QwWayStatisticsListVO(QwStatisticsParam param);

    List<JSONObject> selectQwWayStatisticsCounts(Map<String, Object> map);

    void updateQwContactWayByLoss(QwExternalContact qwExternalContact);

    void addWatchLogIfNeeded(Integer videoId, Integer courseId,
                                     String qwUserId, String companyUserId,
                                     String companyId, String externalId);
}
